<?php

/*
Plugin Name: Skylark Vkontakte Group Wall Auto-Post
Plugin URI:
Description: Automatic post on the Vkontakte Group Wall
Version: 0.3.5.2
Author: Oleg Zhavoronkin
Author URI: http://webstudy.com.ua
*/


add_option("skylark_vk_application_id", '', "Vkontakte application id", 'no'); // default value
add_option("skylark_vk_group_id", '', "Vkontakte group id", 'no'); // default value
add_option("skylark_vk_autopost_on_publish", '', "Automatically prompt the user with the post to wall dialog", 'no'); // default value
add_option("skylark_vk_use_excerpt_text", '', "Use excerpt as a default post text", 'no'); // default value


// WP 3.0+
// add_action( 'add_meta_boxes', 'myplugin_add_custom_box' );

// backwards compatible
add_action('admin_init', 'myplugin_add_custom_box', 1);

add_action('save_post', 'mysave');
add_action('save_page', 'mysave');

function mysave($post_id)
{
	setcookie('vk_post_saved', 1);
	return $post_id;
}

function myplugin_add_custom_box()
{
	add_meta_box('vgwp', 'VKontakte Group Wall Publisher', 'add_custom_wall_publish_option', 'post');
	add_meta_box('vgwp', 'VKontakte Group Wall Publisher', 'add_custom_wall_publish_option', 'page');
}


function add_custom_wall_publish_option($post)
{
	if ($post->post_status != 'publish') {
		echo 'Post/Page should be Published first!';
		return false;
	}

	$vkontakteGroupId = get_option('skylark_vk_group_id');
	$vkontakteApplicationId = get_option('skylark_vk_application_id');
	$autopost = get_option('skylark_vk_autopost_on_publish') && isset($_COOKIE['vk_post_saved']) && $_COOKIE['vk_post_saved'] == 1;
	$excerptUse = get_option('skylark_vk_use_excerpt_text');
	
	$link = get_permalink($post->ID);

	$title = get_the_title();

	$excerpt = get_the_excerpt();
	if (empty($excerpt)) {
		$excerpt = get_the_title();
	} else if (strlen($excerpt > 150)) {
		$excerpt = substr($excerpt,0,147) . '...';
	}

	?>

<script src="http://vkontakte.ru/js/api/openapi.js" type="text/javascript"></script>
<script type="text/javascript">
  VK.init({
      apiId: <?= $vkontakteApplicationId;?>
    });
  	function postToWall() {

		VK.Auth.getLoginStatus(function(response){
			if (response.session) {
				var title = '<?= $title ?>';
				var excerpt = '<?= $excerpt ?>'

				if (document.getElementById('vgwp_publish_custom_text').checked) {
					var title = document.getElementById('vgwp_publish_text').value;
				}
				if (document.getElementById('vgwp_publish_excerpt_text').checked) {
					var title = excerpt;
				}
				
				VK.Api.call('wall.post', {owner_id:-<?=$vkontakteGroupId?>, from_group:1, message:title, attachments: '<?=$link;?>'}, function(r){
					if (r.error && r.error.error_code == '10008') {
						VK.Auth.logout();
						postToWall();
					}
				});
			  } else {
				VK.Auth.login(function(authR){
					if (authR.session) {
						postToWall();
					}
				});
			  }
		});
	}
</script>
<table>
	<tr>
		<td colspan="2">&nbsp;</td>
	</tr>
	<tr>
		<th scope="row" style="text-align:right; vertical-align:top;">
			Message Text
		</th>
		<td>
			<input type="radio" name="vgwp_publish_text_variant" <?php if(empty($excerptUse)) {?>checked="1"<?php }?> value="1" checked="1" id="var4"/><label for="var4">Post title</label><br/><br/>
			<input type="radio" id="vgwp_publish_excerpt_text" name="vgwp_publish_text_variant" <?php if(!empty($excerptUse)) {?>checked="1"<?php }?>  value="2"/><label for="vgwp_publish_excerpt_text">Use excerpt</label><br/><br/>
			<input type="radio" id="vgwp_publish_custom_text" name="vgwp_publish_text_variant"  value="3"/><label for="vgwp_publish_custom_text">Custom text(enter below)</label><br/><br/>
			<textarea id="vgwp_publish_text" stype="width:300px;height:200px"></textarea>
		</td>
	</tr>
	<tr>
		<th scope="row" style="text-align:right; vertical-align:top;">
		</th>
		<td>
			<a href="javascript:void(0)" onclick="postToWall()" class="button-primary">Post to Wall</a>
			<?php if ($autopost) {?>
				<script type="text/javascript">postToWall();</script>
			<?php } ?>
			<script type="text/javascript">document.cookie = 'vk_post_saved=0';</script>
		</td>
	</tr>
</table>
<?php

}

function skylark_vkontakte_wall_post_options_page()
{
	if ($_POST) {
		if ($_POST['skylark_vk_application_id']) {
			update_option('skylark_vk_application_id', $_POST['skylark_vk_application_id']);
		}
		if ($_POST['skylark_vk_group_id']) {
			update_option('skylark_vk_group_id', $_POST['skylark_vk_group_id']);
		}
		if ($_POST['skylark_vk_autopost_on_publish']) {
			update_option('skylark_vk_autopost_on_publish', $_POST['skylark_vk_autopost_on_publish']);
		} else {
			update_option('skylark_vk_autopost_on_publish', '');
		}

		if ($_POST['skylark_vk_use_excerpt_text']) {
			update_option('skylark_vk_use_excerpt_text', $_POST['skylark_vk_use_excerpt_text']);
		} else {
			update_option('skylark_vk_use_excerpt_text', '');
		}
	}



	$vkontakteApplicationId = get_option('skylark_vk_application_id');
	$vkontakteGroupId = get_option('skylark_vk_group_id');
	$autopost = get_option('skylark_vk_autopost_on_publish');
	$excerptUse = get_option('skylark_vk_use_excerpt_text');
	$autopostText = '';
	if ($autopost) {
		$autopostText = 'checked="checked"';
	}

	$excerptUseText = '';
	if ($excerptUse) {
		$excerptUseText = 'checked="checked"';
	}

	print '
	<div class="wrap">
	<h2>Vkontakte Group Wall Post setup</h2>
	<form method="post" action="http://' . $_SERVER['HTTP_HOST'] . $_SERVER['REQUEST_URI'] . '">

	<p>Application ID of your vkontakte website application</p>
	<input type="text" id="skylark_vk_application_id" name="skylark_vk_application_id" value="' . $vkontakteApplicationId . '">

	<p>Vkontakte GroupId you whant to post to</p>
	<input type="text" id="skylark_vk_group_id" name="skylark_vk_group_id" value="' . $vkontakteGroupId . '">

	<p>Automatically post to wall on post publish</p>
	<input type="checkbox" id="skylark_vk_autopost_on_publish" name="skylark_vk_autopost_on_publish" value="1" ' . $autopostText . '>
	<label for="skylark_vk_autopost_on_publish">Post automatically</label>

	<p>Use excerpt as a default wall post text</p>
	<input type="checkbox" id="skylark_vk_use_excerpt_text" name="skylark_vk_use_excerpt_text" value="1" ' . $excerptUseText . '>
	<label for="skylark_vk_use_excerpt_text">Use excerpt</label>

	<p class="submit" style="width:420px;"><input type="submit" value="Submit &raquo;" /></p>
	</form>
	</div>
	';
}

function skylark_vk_group_post_admin_page()
{
	add_submenu_page('options-general.php', 'Vkontakte Group Wall Post', 'Vkontakte Group Wall Post', 9, 'skylark-vk-groupwall-post.php', 'skylark_vkontakte_wall_post_options_page');
}


add_action('admin_menu', 'skylark_vk_group_post_admin_page');